Main:
  #include "LegoLibrary.bas"
  gosub CreateEnvironment:
  SoundPort   = 1
  LinePort    = 2
  RangePort   = 3
  BumperPort  = 4 
  call LegoInit(34)
  call LegoRangeInit(RangePort)
  call LegoLineInit(LinePort)
  call LegoBumperInit(BumperPort)
  call LegoSoundInit(SoundPort)
  while true
    gosub FollowLineTillBump
    gosub LegoRetreat
    gosub LegoFaceRight
    gosub FollowWallTillLine
    gosub LegoAdvance
    gosub FindLineAgain
  wend
end


CreateEnvironment:
  gosub DrawLine
  Circle 250,250,400,450,black,black
  Circle 550,300,600,380,black,black
  Circle 570,270,700,340,black,black
  Circle 600,100,700,150,black,black
  Rectangle 100,100,170,150,black,black
return

FollowLineTillBump:
    repeat
      call LegoLineSensor(2,a)
      if a=1 
        gosub LegoHardRight
      else
        gosub LegoHardLeft
      endif
      call LegoSoundSensor(SoundPort,150,s)
      if s then gosub AboutFace
      call LegoBumperSensor(BumperPort,b) 
    until b
return

FollowWallTillLine:
  gosub LegoLookLeft
  repeat
    call LegoRangeSensor(_RangePort,R)
    if R<8
      gosub LegoEasyRight
    elseif R>12 
      gosub LegoHardLeft
    else
      gosub LegoEasyLeft
    endif
    call LegoLineSensor(_LinePort,L)
  until L
return

FindLineAgain:
  repeat
    call LegoDriveMotors(SLOW,-SLOW)
    call LegoLineSensor(LinePort,s)
  until s
return

AboutFace:
  gosub LegoFaceRight
  gosub FindLineAgain
return
